data edgedata;
	input i j cost;
	datalines;
1 2 .
1 3 .
2 3 .
2 4 .
3 5 .
;
run;

proc optmodel;
	set <num,num> EDGES;
	num cost {EDGES} init 1;
	read data edgedata nomiss into EDGES=[i j] cost;

	set NODES = union {<i,j> in EDGES} {i,j};
	put (card(NODES))=;
	set PERIODS = 1..card(NODES);

	/* HasMoved[i,t] = 1 if node i has moved by time t, 0 otherwise */
	var HasMoved {NODES, PERIODS} binary;
	var IsCutEdge {EDGES, PERIODS} >= 0;

	min TotalCost = sum {<i,j> in EDGES, t in PERIODS} cost[i,j] * IsCutEdge[i,j,t];

	con one_move_at_a_time {t in PERIODS}:
		sum {i in NODES} HasMoved[i,t] = t;

	con once_moved_always_moved {i in NODES, t in PERIODS diff {1}}:
		HasMoved[i,t-1] <= HasMoved[i,t];

	con IsCutEdge_def1 {<i,j> in EDGES, t in PERIODS}:
		IsCutEdge[i,j,t] >= HasMoved[i,t] - HasMoved[j,t];
	con IsCutEdge_def2 {<i,j> in EDGES, t in PERIODS}:
		IsCutEdge[i,j,t] >= HasMoved[j,t] - HasMoved[i,t];

	solve with milp / primalin;
	print HasMoved;
quit;
